<template>
  <div>
    <Ariane
      type="breadcrumb trunk"
      :breadcrumbs="breadcrumbs"
      :params="params"
    />
    <div v-if="pageData" class="content">
      <HeaderDesktop
        class="header-desktop"
        :title="pageData.title"
        :bg-url="headerImage"
      />
      <HeaderMobile
        class="header-mobile"
        :title="pageData ? pageData.title : ''"
        :bg-url="headerImage"
      />

      <template v-if="sections.length">
        <div v-for="(section, index) of sections" :key="`section-${index}`">
          <SerieSection
            v-if="section.type === 'selection'"
            :data="section.data"
            :should-be-loaded="true"
            :is-subscription="false"
            :no-price="section.data.showPrice === '0'"
          />
          <component :is="getSection(section)" v-else :data="section.data" />
        </div>
      </template>
      <CtaSubscriptionSection v-if="showSubscriptionBanner" />
      <Loader :display="isLoading" />
    </div>
  </div>
</template>

<script>
import Ariane from '~/components/ui/Ariane'
import Loader from '~/components/ui/Loader'
import SerieSection from '~/components/sections/SerieSection'
import CtaSubscriptionSection from '~/components/sections/CtaSubscriptionSection'
import HeaderDesktop from '~/components/Universe/HeaderDesktop'
import HeaderMobile from '~/components/Universe/HeaderMobile'
import ImageSection from '~/components/Universe/ImageSection'
import TextSection from '~/components/Universe/TextSection'
import SRCommentSection from '~/components/Universe/SRCommentSection'

export default {
  name: 'Universe',
  components: {
    Ariane,
    Loader,
    SerieSection,
    CtaSubscriptionSection,
    HeaderDesktop,
    HeaderMobile,
    ImageSection,
    TextSection,
    SRCommentSection
  },

  async fetch() {
    await this.loadPage()
  },

  data() {
    return {
      pageData: null,
      isLoading: false,
      showSubscriptionBanner: false,
      title: this.$t('breadcrumb.universe'),
      breadcrumbs: [this.$t('breadcrumb.home'), this.$t('breadcrumb.universe')],
      params: [`/${this.$i18n.locale}/`, `/${this.$i18n.locale}/universe`]
    }
  },

  computed: {
    sections() {
      if (!this.pageData) return []
      let position = 0
      const sections = this.pageData.blocks.map((section) => {
        let dt

        if (section.type === 'selection') {
          dt = {
            title: section.title,
            reference: 'selection',
            shelf: null,
            itemId: section.selection,
            series: null,
            showPrice: section.show_price
          }
        } else if (section.type === 'text_with_image') {
          section.position = ++position
          dt = section
        } else {
          dt = section
        }

        return {
          type: section.type,
          data: dt
        }
      })

      return sections
    },

    headerImage() {
      return this.pageData
        ? `${this.$config.izneoUrl}/${this.$i18n.locale}/images/universe-page/${this.pageData.id}.jpg?v=${this.pageData.version}`
        : ''
    },

    isAuthenticated() {
      return this.$auth.loggedIn
    },

    ui() {
      return this.$auth.loggedIn && this.$auth.user ? this.$auth.user : {}
    },

    isAboUser() {
      return 'hasActiveClassicSubscription' in this.ui
        ? this.ui.hasActiveClassicSubscription
        : false
    }
  },

  watch: {
    isAuthenticated() {
      this.updateShowSubscriptionBanner()
    },

    ui() {
      this.updateShowSubscriptionBanner()
    }
  },

  async mounted() {
    this.updateShowSubscriptionBanner()
  },

  methods: {
    async loadPage() {
      try {
        const id = this.$api.extractIdFromSlugId(this.$route.params.slug).id
        const data = await this.$api.universe(id)

        if (typeof data !== 'object' || data === null) {
          this.$nuxt.error({
            statusCode: 404,
            message: 'This page does not exist'
          })
          return
        }

        this.pageData = data
        this.title = `${this.$t('breadcrumb.universe')} - ${
          this.pageData.title
        }`

        this.breadcrumbs.push(this.pageData.title)
        this.params.push('')
      } finally {
        this.isLoading = false
      }
    },

    getSection(section) {
      switch (section.type) {
        case 'selection':
          return 'SerieSection'
        case 'text_with_image':
          return 'ImageSection'
        case 'text':
          return 'TextSection'
        case 'super_reader_comment':
          return 'SRCommentSection'
      }
    },

    updateShowSubscriptionBanner() {
      this.showSubscriptionBanner =
        !this.isAboUser && this.pageData.show_subscription === '1'
    }
  },

  head() {
    return {
      title: this.title,
      meta: [
        {
          hid: 'description',
          name: 'description',
          content:
            this.pageData &&
            this.pageData.description &&
            this.pageData.description.length
              ? this.pageData.description
              : ''
        },
        // facebook METAs
        {
          hid: 'og:title',
          name: 'og:title',
          content: this.title
        },
        {
          hid: 'og:description',
          name: 'og:description',
          content:
            this.pageData &&
            this.pageData.description &&
            this.pageData.description.length
              ? this.pageData.description.slice(0, 400)
              : ''
        },
        {
          hid: 'og:image',
          name: 'og:image',
          content: this.pageData
            ? `${this.$config.izneoUrl}/${this.$i18n.locale}/images/universe-page/${this.pageData.id}-w360.jpg?v=${this.pageData.version}`
            : ''
        },
        {
          hid: 'og:image:width',
          name: 'og:image:width',
          content: this.pageData ? 360 : 0
        }
      ]
    }
  }
}
</script>

<style lang="scss" scoped>
::v-deep .text-section,
::v-deep .image-section {
  li {
    list-style-type: disc;
    list-style-position: inside;
    display: list-item;
    line-height: 1.7;
  }
}

.header-mobile {
  display: none;
}

.header-desktop {
  display: block;
}

@media (max-width: 768px) {
  .header-mobile {
    display: block;
  }

  .header-desktop {
    display: none;
  }
}
</style>
